//+------------------------------------------------------------------+
//|                                                  TradingTime.mq4 |
//|                        Copyright  2011, NQueiros Software Corp. |
//|                                   Email:nqueirosmail@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, NQueiros Software Corp."
#property link      "Email:nqueirosmail@hotmail.com"
#property library
// This Function is to Process the Time ok Working
// This Function Will Return the True if it is Between Start Time and End Time
// Revised/Version 02/03/2012
#import "WordsToStringArray1D.ex4" int WordsToStringArray1D(string &Array[],string Words,int Start,string SS);
#import "InitializeStringArray1D.ex4" int InitializeStringArray1D(string &Array[],string Word,int DS0S,int DS0E);
#import "DayStringToInt.ex4" int DayStringToInt(string day);

bool TradingTime(string StartDay="Sunday",    //0- Day to Start
                 string StartTime="23:00:00", //1- Time to Start
                 string EndDay="Friday",      //2- Day to End
                 string EndTime="22:59:59")   //3- Time to End
   {
    //--- Memory Array-------------------------------------------------------------
    string MA[6];                             // Memory Array
    InitializeStringArray1D(MA,"",0,-1);      // Initialize Array[]
    WordsToStringArray1D(MA,StartTime,0,":"); // Extract Parameters to Memory Array
    WordsToStringArray1D(MA,EndTime,3,":");   // Extract Parameters to Memory Array
   
    int Sday=DayStringToInt(StartDay); // Integer Start Day Extern Set
    int Shour=StrToInteger(MA[0]);     // Start Hour
    int SMinute=StrToInteger(MA[1]);   // Start Minute
    int SSecond=StrToInteger(MA[2]);   // Start Second
    
    int Eday=DayStringToInt(EndDay);   // Integer End Day Extern Set
    int Ehour=StrToInteger(MA[3]);     // End Hour
    int EMinute=StrToInteger(MA[4]);   // End Minute
    int ESecond=StrToInteger(MA[5]);   // End Second
    
    // Prevent Errors/Bugs
    if(Sday<0 || Eday<0)return(false);
    if(Shour<0 || Shour>23 || Ehour<0 || Ehour>23)return(false);
    if(SMinute<0 || SMinute>59 || EMinute<0 || EMinute>59)return(false);
    if(SSecond<0 || SSecond>59 || ESecond<0 || ESecond>59)return(false);
    
    // Days && Hour Equals
    if(DayOfWeek()==Sday && DayOfWeek()==Eday && Hour()==Shour && Hour()==Ehour)
      {
       if(Minute()==SMinute && Minute()==EMinute && Seconds()>=SSecond && Seconds()<=ESecond)return(true);
       if(Minute()==SMinute && Minute()<EMinute && Seconds()>=SSecond)return(true);
       if(Minute()>SMinute && Minute()==EMinute && Seconds()<=ESecond)return(true);
       if(Minute()>SMinute && Minute()<EMinute)return(true);
      } 
    
    // Days Equals
    if(DayOfWeek()==Sday && DayOfWeek()==Eday)
      {
       if(Hour()==Shour && Hour()<Ehour && Minute()==SMinute && Seconds()>=SSecond)return(true);
       if(Hour()>Shour && Hour()==Ehour && Minute()==EMinute && Seconds()<=ESecond)return(true);
       if(Hour()==Shour && Hour()<Ehour && Minute()>SMinute)return(true);
       if(Hour()>Shour && Hour()==Ehour && Minute()<EMinute)return(true);
       if(Hour()>Shour && Hour()<Ehour)return(true);
      }
    
    // Day Start Control
    if(DayOfWeek()==Sday && DayOfWeek()<Eday && Hour()==Shour && Minute()==SMinute && Seconds()>=SSecond)return(true);  
    if(DayOfWeek()==Sday && DayOfWeek()<Eday && Hour()==Shour && Minute()>SMinute)return(true);
    if(DayOfWeek()==Sday && DayOfWeek()<Eday && Hour()>Shour)return(true);
    
    // Day End Control
    if(DayOfWeek()>Sday && DayOfWeek()==Eday && Hour()==Ehour && Minute()==EMinute && Seconds()<=ESecond)return(true);
    if(DayOfWeek()>Sday && DayOfWeek()==Eday && Hour()==Ehour && Minute()<EMinute)return(true);
    if(DayOfWeek()>Sday && DayOfWeek()==Eday && Hour()<Ehour)return(true);
    
    // Trading Days
    if(DayOfWeek()>Sday && DayOfWeek()<Eday)return(true);
    
    return(false);
   }